private {
    import doodle.core.backtrace;
    import doodle.core.logging;
    import doodle.core.backtrace;

    import doodle.dia.tool_layer;
    import doodle.dia.standard_tools;
    import doodle.dia.grid_layer;
    import doodle.dia.page_layer;

    import doodle.gtk.canvas;
    import doodle.gtk.toolbar;

    import gtk.Main;
    import gtk.MainWindow;
    import gtk.VBox;

    import std.stdio;
}

void main(string[] args) {
    trace("Test trace");
    /+
    trace("Test trace");
    info("Test trace");
    message("Test trace");
    warning("Test trace");
    error("Test trace");
    fatal("Test trace");
    +/

    trace("Test trace1");
    Main.init(args);
    trace("Test trace2");
    auto window = new MainWindow("Doodle");
    trace("Test trace3");
    auto vbox = new VBox(false, 0);
    trace("Test trace4");
    auto toolBar = new ToolBar;
    trace("Test trace5");
    vbox.packStart(toolBar, false, false, 0);
    Tool[] tools;
    tools ~= new PanTool;
    tools ~= new ZoomTool;
    tools ~= new LassoTool;
    trace("Test trace4");
    auto toolLayer = new ToolLayer(tools, "Tools");
    auto gridLayer = new GridLayer("Grid");
    Layer[] layers;
    trace("Test trace5");
    layers ~= new PageLayer("Page");
    layers ~= gridLayer;
    layers ~= toolLayer;
    trace("Test trace6");
    auto canvas = new Canvas(layers, toolLayer, gridLayer, 120.0);
    trace("Test trace7");
    vbox.packStart(canvas, true, true, 0);
    trace("Test trace8");
    window.add(vbox);
    trace("Test trace9");
    window.setDefaultSize(380, 380);
    window.showAll();
    trace("Test trace8");
    Main.run();
}
